commit:     5cf79d0718816ddef25b7ddc3353d4f4975dbb6e
Author:     Andrew Ammerlaan <andrewammerlaan <AT> gentoo <DOT> org>
AuthorDate: Wed May 19 13:15:23 2021 +0000
Commit:     Andrew Ammerlaan <andrewammerlaan <AT> gentoo <DOT> org>
CommitDate: Thu May 20 09:42:27 2021 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5cf79d07

dev-python/QtPy: allow use of pyside2, but better this time

Closes: https://bugs.gentoo.org/790764
Package-Manager: Portage-3.0.18, Repoman-3.0.3
Closes: https://github.com/gentoo/gentoo/pull/20871
Signed-off-by: Andrew Ammerlaan <andrewammerlaan <AT> gentoo.org>

 dev-python/QtPy/QtPy-1.9.0-r4.ebuild | 137 +++++++++++++++++++++++++++++++++++
 dev-python/QtPy/metadata.xml         |  17 +++++
 2 files changed, 154 insertions(+)

diff --git a/dev-python/QtPy/QtPy-1.9.0-r4.ebuild 
b/dev-python/QtPy/QtPy-1.9.0-r4.ebuild
new file mode 100644
index 00000000000..b31189ce6bd
--- /dev/null
+++ b/dev-python/QtPy/QtPy-1.9.0-r4.ebuild
@@ -0,0 +1,137 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{7..8} )
+
+inherit distutils-r1 virtualx
+
+DESCRIPTION="Abstraction layer on top of PyQt5 and PySide2 and additional 
custom QWidgets"
+HOMEPAGE="https://github.com/spyder-ide/qtpy/";
+SRC_URI="mirror://pypi/${PN:0:1}/${PN}/${P}.tar.gz"
+
+LICENSE="MIT"
+SLOT="0"
+KEYWORDS="~amd64 ~arm64 ~x86"
+
+_IUSE_QT_MODULES="
+       declarative designer gui help location multimedia network opengl
+       positioning printsupport sensors serialport sql svg testlib webchannel
+       webengine websockets widgets x11extras xml xmlpatterns
+"
+IUSE="+pyqt5 pyside2 ${_IUSE_QT_MODULES}"
+unset _IUSE_QT_MODULES
+
+REQUIRED_USE="|| ( pyqt5 pyside2 )"
+
+# These flags are currently *not* common to both the PySide2 and PyQt5 ebuild
+# Disable them for now, please check periodically if this is still up to date.
+#      bluetooth? ( pyqt5 )
+#      dbus? ( pyqt5 )
+#      networkauth? ( pyqt5 )
+#      webkit? ( pyqt5 )
+#
+#      3d? ( pyside2 )
+#      charts? ( pyside2 )
+#      concurrent? ( pyside2 )
+#      datavis? ( pyside2 )
+#      scxml? ( pyside2 )
+#      script? ( pyside2 )
+#      scripttools? ( pyside2 )
+#      speech? ( pyside2 )
+
+# WARNING: the obvious solution of using || for PyQt5/pyside2 is not going
+# to work.  The package only checks whether PyQt5/pyside2 is installed, it does
+# not verify whether they have the necessary modules (i.e. satisfy the USE 
dep).
+#
+# Webengine is a special case, because PyQt5 provides this in a separate 
package
+# while PySide2 ships it in the same package.
+#
+# declarative/qml/quick is a special case, because PyQt5 bundles the bindings
+# for qml and quick in one flag: declarative PySide2 does not.
+#
+# The PyQt5 ebuild currently enables xml support unconditionally, the flag is
+# added anyway with a (+) to make it future proof if the ebuild were to change
+# this behaviour in the future.
+#
+# The PySide2 ebuild currently enables opengl and serialport support
+# unconditionally, the flag is added anyway with a (+) to make it future proof
+# if the ebuild were to change this behaviour in the future.
+RDEPEND="
+       pyqt5? (
+               dev-python/PyQt5[${PYTHON_USEDEP}]
+               dev-python/PyQt5[declarative?,designer?,gui?,help?,location?]
+               dev-python/PyQt5[multimedia?,network?,opengl?,positioning?]
+               dev-python/PyQt5[printsupport?,sensors?,serialport?,sql?,svg?]
+               dev-python/PyQt5[testlib?,webchannel?,websockets?,widgets?]
+               dev-python/PyQt5[x11extras?,xml(+)?,xmlpatterns?]
+               webengine? ( dev-python/PyQtWebEngine[${PYTHON_USEDEP}] )
+       )
+       pyside2? (
+               dev-python/pyside2[${PYTHON_USEDEP}]
+               dev-python/pyside2[designer?,gui?,help?,location?,multimedia?]
+               
dev-python/pyside2[network?,opengl(+)?,positioning?,printsupport?]
+               dev-python/pyside2[sensors?,serialport(+)?,sql?,svg?,testlib?]
+               dev-python/pyside2[webchannel?,webengine?,websockets?,widgets?]
+               dev-python/pyside2[x11extras?,xml?,xmlpatterns?]
+               declarative? ( dev-python/pyside2[qml,quick] )
+       )
+"
+
+# The QtPy testsuite skips tests for bindings that are not installed, so here 
we
+# ensure that everything is available and all tests are run. Note that not
+# all flags are available in PyQt5/PySide2, so some tests are still skipped.
+BDEPEND="
+       test? (
+               dev-python/mock[${PYTHON_USEDEP}]
+               dev-python/PyQt5[${PYTHON_USEDEP}]
+               
dev-python/PyQt5[bluetooth,dbus,declarative,designer,gui,help,location]
+               
dev-python/PyQt5[multimedia,network,networkauth,opengl,positioning]
+               
dev-python/PyQt5[printsupport,sensors,serialport,sql,svg,testlib]
+               
dev-python/PyQt5[webchannel,webkit,websockets,widgets,x11extras,xml(+)]
+               dev-python/PyQt5[xmlpatterns]
+               dev-python/PyQtWebEngine[${PYTHON_USEDEP}]
+               dev-python/pyside2[${PYTHON_USEDEP}]
+               
dev-python/pyside2[3d,charts,concurrent,datavis,designer,gui,help]
+               
dev-python/pyside2[location,multimedia,network,opengl(+),positioning]
+               
dev-python/pyside2[printsupport,qml,quick,script,scripttools,scxml]
+               dev-python/pyside2[sensors,serialport(+),speech,sql,svg,testlib]
+               
dev-python/pyside2[webchannel,webengine,websockets,widgets,x11extras]
+               dev-python/pyside2[xml,xmlpatterns]
+)"
+
+distutils_enable_tests pytest
+
+src_prepare() {
+       default
+       if ! use pyqt5; then
+               sed -i -e "s/from PyQt5.QtCore import/raise ImportError #/" 
qtpy/__init__.py || die
+       fi
+       if ! use pyside2; then
+               sed -i -e "s/from PySide2 import/raise ImportError #/" 
qtpy/__init__.py || die
+       fi
+
+       # Disable outdated PyQt4 and PySide
+       sed -i -e "s/from PyQt4.Qt import/raise ImportError #/" 
qtpy/__init__.py || die
+       sed -i -e "s/from PyQt4.QtCore import/raise ImportError #/" 
qtpy/__init__.py || die
+       sed -i -e "s/from PySide import/raise ImportError #/" qtpy/__init__.py 
|| die
+}
+
+src_test() {
+       virtx python_foreach_impl python_test
+}
+
+python_test() {
+       local -x QT_API
+       for QT_API in pyqt5 pyside2; do
+               epytest
+       done
+}
+
+pkg_postinst() {
+       if use pyqt5 && use pyside2; then
+               ewarn "You have enabled both PyQt5 and PySide2, note that QtPy 
will default"
+               ewarn "to PyQt5 unless the QT_API environment variable 
overrides this."
+       fi
+}

diff --git a/dev-python/QtPy/metadata.xml b/dev-python/QtPy/metadata.xml
index f0ef6662c62..605a0838da7 100644
--- a/dev-python/QtPy/metadata.xml
+++ b/dev-python/QtPy/metadata.xml
@@ -15,13 +15,30 @@
                Basically, you can write your code as if you were using PySide2 
but import Qt modules from qtpy instead of PySide2 (or PyQt5)
        </longdescription>
        <use>
+               <flag name="pyqt5">Use <pkg>dev-python/PyQt5</pkg> as Qt for 
Python implementation</flag>
+               <flag name="pyside2">Use <pkg>dev-python/pyside2</pkg> as Qt 
for Python implementation</flag>
+               <flag name="declarative">Pull in bindings for the QtQml/QtQuick 
modules and enable the qmlscene plugin</flag>
                <flag name="designer">Pull in bindings for the QtDesigner 
module and enable the designer plugin</flag>
                <flag name="gui">Pull in bindings for the QtGui module</flag>
+               <flag name="help">Pull in bindings for the QtHelp module</flag>
+               <flag name="location">Pull in bindings for the QtLocation 
module</flag>
+               <flag name="multimedia">Pull in QtMultimedia and 
QtMultimediaWidgets modules</flag>
+               <flag name="network">Pull in bindings for the QtNetwork 
module</flag>
                <flag name="opengl">Pull in bindings for the QtOpenGL 
module</flag>
+               <flag name="positioning">Pull in bindings for the QtPositioning 
module</flag>
                <flag name="printsupport">Pull in bindings for the 
QtPrintSupport module</flag>
+               <flag name="sensors">Pull in bindings for the QtSensors 
module</flag>
+               <flag name="serialport">Pull in bindings for the QtSerialPort 
module</flag>
+               <flag name="sql">Pull in bindings for the QtSql module</flag>
                <flag name="svg">Pull in bindings for the QtSvg module</flag>
                <flag name="testlib">Pull in bindings for the QtTest 
module</flag>
+               <flag name="webchannel">Pull in bindings for the QtWebChannel 
module</flag>
                <flag name="webengine">Pull in QtWebEngine and 
QtWebEngineWidgets modules</flag>
+               <flag name="websockets">Pull in bindings for the QtWebSockets 
module</flag>
+               <flag name="widgets">Pull in bindings for the QtWidgets 
module</flag>
+               <flag name="x11extras">Pull in bindings for the QtX11Extras 
module</flag>
+               <flag name="xmlpatterns">Pull in bindings for the QtXmlPatterns 
module</flag>
+               <flag name="xml">Pull in QtXml module</flag>
        </use>
        <upstream>
                <remote-id type="github">spyder-ide/qtpy</remote-id>

Reply via email to